﻿//whither.js for Perlenspiel 3.1

//Whither
//Patrick Petersen

//Music by Kevin MacLeod
//"Fantastic Dim Bar"
//<http://freepd.com/Piano/Fantastic%20Dim%20Bar>

/*
Perlenspiel is a scheme by Professor Moriarty (bmoriarty@wpi.edu).
Perlenspiel is Copyright © 2009-14 Worcester Polytechnic Institute.
This file is part of Perlenspiel.

Perlenspiel is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Perlenspiel is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lesser General Public License for more details.

You may have received a copy of the GNU Lesser General Public License
along with Perlenspiel. If not, see <http://www.gnu.org/licenses/>.
*/

/*jslint nomen: true, white: true */
/*global PS */

var WHITHER = {
	WIDTH : 10,
	HEIGHT : 10,
	XMAX : 9,
	YMAX : 9,
	play : true,
	status : false,
	level : 0, // controls starting level; default = 0
	x : 0, y : 0, // coordinates of player bead
	size : 0,
	status : 0,
	gx : -1, gy : -1, // coordinates of goal bead, -1 none
	awx : -1, awy : -1, // alpha coordinates of wall bead, -1 if none
	awp : 0, // alpha delta for wall
	afx : -1, afy: -1, // alpha coordinates of food bead, -1 if none
	afp: 0, // alpha delta for food
	agp: 0, // alpha delta for goal
	timerID : null,

	nextLevel : function ()
	{
		"use strict";

		PS.color( PS.ALL, PS.ALL, PS.COLOR_GRAY );
		PS.border( PS.ALL, PS.ALL, 0 );
		PS.borderColor( PS.ALL, PS.ALL, PS.COLOR_GRAY );

		WHITHER.level += 1;
		switch ( WHITHER.level )
		{
			case 1:
			{
				WHITHER.x = 1;
				WHITHER.y = 1;
				WHITHER.size = 0;
				break;
			}
			case 2:
			{
				if( !WHITHER.status )
				{
					WHITHER.status = true;
					PS.statusText("Whither");
					PS.audioPlay("whither");
				}

				WHITHER.x = 2;
				WHITHER.y = 6;
				WHITHER.size = 2;
				WHITHER.gx = 7;
				WHITHER.gy = 6;
				break;
			}
			case 3:
			{
				WHITHER.x = 2;
				WHITHER.y = 2;
				WHITHER.size = 2;
				WHITHER.gx = 7;
				WHITHER.gy = 7;
				break;
			}
			case 4:
			{
				WHITHER.x = 3;
				WHITHER.y = 5;
				WHITHER.size = 4;
				WHITHER.gx = 7;
				WHITHER.gy = 5;

				PS.color(5,4,PS.COLOR_WHITE);
				PS.color(5,5,PS.COLOR_WHITE);
				PS.color(5,6,PS.COLOR_WHITE);
				break;
			}
			case 5:
			{
				WHITHER.x = 7;
				WHITHER.y = 7;
				WHITHER.size = 2;
				WHITHER.gx = 2;
				WHITHER.gy = 2;

				PS.color(0,4,PS.COLOR_WHITE);
				PS.color(2,4,PS.COLOR_WHITE);
				PS.color(2,6,PS.COLOR_WHITE);
				PS.color(2,8,PS.COLOR_WHITE);
				PS.color(3,3,PS.COLOR_WHITE);
				PS.color(4,0,PS.COLOR_WHITE);
				PS.color(4,6,PS.COLOR_WHITE);
				PS.color(4,8,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(5,5,PS.COLOR_WHITE);
				PS.color(6,6,PS.COLOR_WHITE);
				PS.color(7,3,PS.COLOR_WHITE);
				PS.color(8,4,PS.COLOR_WHITE);
				PS.color(8,6,PS.COLOR_WHITE);
				PS.color(9,9,PS.COLOR_WHITE);

				break;
			}
			case 6:
			{
				WHITHER.x = 7;
				WHITHER.y = 2;
				WHITHER.size = 4;
				WHITHER.gx = 2;
				WHITHER.gy = 7;

				PS.color(1,2,PS.COLOR_BLACK);
				PS.border(1,2,20);

				break;
			}
			case 7:
			{
				WHITHER.x = 3;
				WHITHER.y = 7;
				WHITHER.size = 4;
				WHITHER.gx = 8;
				WHITHER.gy = 2;

				PS.color(4,3,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(6,3,PS.COLOR_WHITE);
				PS.color(6,4,PS.COLOR_WHITE);

				PS.color(5,4,PS.COLOR_BLACK);
				PS.border(5,4,20);

				break;
			}
			case 8:
			{
				WHITHER.x = 1;
				WHITHER.y = 8;
				WHITHER.size = 2;
				WHITHER.gx = 8;
				WHITHER.gy = 1;

				PS.color(0,6,PS.COLOR_WHITE);
				PS.color(1,6,PS.COLOR_WHITE);
				PS.color(2,6,PS.COLOR_WHITE);
				PS.color(3,6,PS.COLOR_WHITE);
				PS.color(5,8,PS.COLOR_WHITE);
				PS.color(5,9,PS.COLOR_WHITE);
				PS.color(6,0,PS.COLOR_WHITE);
				PS.color(6,3,PS.COLOR_WHITE);
				PS.color(7,3,PS.COLOR_WHITE);
				PS.color(8,3,PS.COLOR_WHITE);
				PS.color(9,3,PS.COLOR_WHITE);

				PS.color(4,1,PS.COLOR_BLACK);
				PS.border(4,1,20);
				PS.color(5,5,PS.COLOR_BLACK);
				PS.border(5,5,20);

				break;
			}
			case 9:
			{
				WHITHER.x = 3;
				WHITHER.y = 5;
				WHITHER.size = 4;
				WHITHER.gx = 7;
				WHITHER.gy = 5;
				WHITHER.awx = 5;
				WHITHER.awy = 5;
				WHITHER.awp = 64;

				PS.color(5,2,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(5,4,PS.COLOR_WHITE);
				PS.color(5,5,PS.COLOR_WHITE);
				PS.color(5,6,PS.COLOR_WHITE);
				PS.color(5,7,PS.COLOR_WHITE);
				PS.color(5,8,PS.COLOR_WHITE);

				PS.alpha(WHITHER.awx,WHITHER.awy,255);
				break;
			}
			case 10:
			{
				WHITHER.x = 8;
				WHITHER.y = 8;
				WHITHER.size = 2;
				WHITHER.gx = 3;
				WHITHER.gy = 3;
				WHITHER.awx = 5;
				WHITHER.awy = 3;
				WHITHER.awp = 48;

				PS.color(3,6,PS.COLOR_WHITE);
				PS.color(3,7,PS.COLOR_WHITE);
				PS.color(3,8,PS.COLOR_WHITE);
				PS.color(3,9,PS.COLOR_WHITE);
				PS.color(5,0,PS.COLOR_WHITE);
				PS.color(5,1,PS.COLOR_WHITE);
				PS.color(5,2,PS.COLOR_WHITE);
				PS.color(4,5,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(5,7,PS.COLOR_WHITE);
				PS.color(6,4,PS.COLOR_WHITE);
				PS.color(6,5,PS.COLOR_WHITE);
				PS.color(6,6,PS.COLOR_WHITE);

				PS.alpha(WHITHER.awx,WHITHER.awy,255);
				break;
			}
			case 11:
			{
				WHITHER.x = 4;
				WHITHER.y = 0;
				WHITHER.size = 6;
				WHITHER.gx = 8;
				WHITHER.gy = 5;
				WHITHER.awx = 6;
				WHITHER.awy = 3;
				WHITHER.awp = 64;

				PS.color(6,0,PS.COLOR_WHITE);
				PS.color(6,1,PS.COLOR_WHITE);
				PS.color(6,2,PS.COLOR_WHITE);
				PS.color(6,3,PS.COLOR_WHITE);
				PS.color(6,4,PS.COLOR_WHITE);
				PS.color(6,5,PS.COLOR_WHITE);
				PS.color(6,6,PS.COLOR_WHITE);

				PS.alpha(WHITHER.awx,WHITHER.awy,255);

				PS.color(5,7,PS.COLOR_BLACK);
				PS.border(5,7,20);
				PS.color(7,7,PS.COLOR_BLACK);
				PS.border(7,7,20);
				break;
			}
			case 12:
			{
				WHITHER.x = 2;
				WHITHER.y = 7;
				WHITHER.size = 8;
				WHITHER.gx = 5;
				WHITHER.gy = 2;
				WHITHER.afx = 5;
				WHITHER.afy = 5;
				WHITHER.afp = 46;

				PS.color(WHITHER.afx,WHITHER.afy,PS.COLOR_BLACK);
				PS.border(WHITHER.afx,WHITHER.afy,20);

				PS.alpha(WHITHER.afx,WHITHER.afy,255);
				break;
			}
			case 13:
			{
				WHITHER.x = 6;
				WHITHER.y = 1;
				WHITHER.size = 10;
				WHITHER.gx = 1;
				WHITHER.gy = 2;
				WHITHER.afx = 5;
				WHITHER.afy = 4;
				WHITHER.afp = 88;

				PS.color(5,5,PS.COLOR_BLACK);
				PS.border(5,5,20);

				PS.color(WHITHER.afx,WHITHER.afy,PS.COLOR_BLACK);
				PS.border(WHITHER.afx,WHITHER.afy,20);

				PS.alpha(WHITHER.afx,WHITHER.afy,255);
				break;
			}
			case 14:
			{
				WHITHER.x = 5;
				WHITHER.y = 2;
				WHITHER.size = 8;
				WHITHER.gx = 6;
				WHITHER.gy = 7;
				WHITHER.afx = 6;
				WHITHER.afy = 3;
				WHITHER.afp = 46;

				PS.color(6,2,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(5,4,PS.COLOR_WHITE);

				PS.color(2,4,PS.COLOR_BLACK);
				PS.border(2,4,20);
				PS.color(WHITHER.afx,WHITHER.afy,PS.COLOR_BLACK);
				PS.border(WHITHER.afx,WHITHER.afy,20);

				PS.alpha(WHITHER.afx,WHITHER.afy,255);
				break;
			}
			case 15:
			{
				WHITHER.x = 1;
				WHITHER.y = 5;
				WHITHER.size = 8;
				WHITHER.gx = 7;
				WHITHER.gy = 2;
				WHITHER.awx = 5;
				WHITHER.awy = 4;
				WHITHER.awp = 20;
				WHITHER.afx = 3;
				WHITHER.afy = 1;
				WHITHER.afp = 46;

				PS.color(5,0,PS.COLOR_WHITE);
				PS.color(5,1,PS.COLOR_WHITE);
				PS.color(5,2,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(5,4,PS.COLOR_WHITE);
				PS.color(5,5,PS.COLOR_WHITE);
				PS.color(6,5,PS.COLOR_WHITE);
				PS.color(7,5,PS.COLOR_WHITE);
				PS.color(8,5,PS.COLOR_WHITE);
				PS.color(9,5,PS.COLOR_WHITE);

				PS.color(2,0,PS.COLOR_BLACK);
				PS.border(2,0,20);
				PS.color(6,4,PS.COLOR_BLACK);
				PS.border(6,4,20);
				PS.color(4,3,PS.COLOR_BLACK);
				PS.border(4,3,20);
				PS.color(WHITHER.afx,WHITHER.afy,PS.COLOR_BLACK);
				PS.border(WHITHER.afx,WHITHER.afy,20);

				PS.alpha(WHITHER.afx,WHITHER.afy,255);
				break;
			}
			case 16:
			{
				WHITHER.x = 4;
				WHITHER.y = 8;
				WHITHER.size = 6;
				WHITHER.gx = 1;
				WHITHER.gy = 3;
				WHITHER.agp = 32;
				break;
			}
			case 17:
			{
				WHITHER.x = 3;
				WHITHER.y = 2;
				WHITHER.size = 0;
				WHITHER.gx = 5;
				WHITHER.gy = 5;
				WHITHER.agp = 24;

				PS.color(2,5,PS.COLOR_WHITE);
				PS.color(3,7,PS.COLOR_WHITE);
				PS.color(3,6,PS.COLOR_WHITE);
				PS.color(3,4,PS.COLOR_WHITE);
				PS.color(4,3,PS.COLOR_WHITE);
				PS.color(5,3,PS.COLOR_WHITE);
				PS.color(6,3,PS.COLOR_WHITE);
				PS.color(7,4,PS.COLOR_WHITE);

				PS.color(1,6,PS.COLOR_BLACK);
				PS.border(1,6,20);
				PS.color(4,8,PS.COLOR_BLACK);
				PS.border(4,8,20);
				break;
			}
			case 18:
			{
				WHITHER.x = 7;
				WHITHER.y = 5;
				WHITHER.size = 6;
				WHITHER.gx = 1;
				WHITHER.gy = 4;
				WHITHER.awx = 3;
				WHITHER.awy = 4;
				WHITHER.awp = 60;
				WHITHER.afx = 3;
				WHITHER.afy = 7;
				WHITHER.afp = 48;
				WHITHER.agp = 26;

				PS.color(4,3,PS.COLOR_WHITE);
				PS.color(3,4,PS.COLOR_WHITE);
				PS.color(5,2,PS.COLOR_WHITE);
				PS.color(4,5,PS.COLOR_WHITE);
				PS.color(6,6,PS.COLOR_WHITE);
				PS.color(7,6,PS.COLOR_WHITE);

				PS.color(WHITHER.afx,WHITHER.afy,PS.COLOR_BLACK);
				PS.border(WHITHER.afx,WHITHER.afy,20);

				PS.alpha(WHITHER.afx,WHITHER.afy,255);
				break;
			}
			default: // the final level
			{
				WHITHER.x = 0;
				WHITHER.y = 7;
				WHITHER.size = 0;
				WHITHER.gx = 9;
				WHITHER.gy = 7;
				WHITHER.agp = 32;
				break;
			}
		}

		// Setup player

		PS.color( WHITHER.x, WHITHER.y, PS.COLOR_BLACK );
		PS.border( WHITHER.x, WHITHER.y, WHITHER.size );

		// Setup goal

		if ( WHITHER.gx >= 0 )
		{
			PS.border( WHITHER.gx, WHITHER.gy, 3 );
			PS.borderColor( WHITHER.gx, WHITHER.gy, PS.COLOR_BLACK );
			PS.borderAlpha( WHITHER.gx, WHITHER.gy, 255);
		}
	},

	update : function ( x, y, dest )
	{
		"use strict";
		var timer, alpha;

		PS.color( WHITHER.x, WHITHER.y, PS.COLOR_GRAY );
		PS.border( WHITHER.x, WHITHER.y, 0 );

		WHITHER.x = x;
		WHITHER.y = y;
		PS.color( x, y, PS.COLOR_BLACK );

		if( dest === PS.COLOR_BLACK )
		{
			WHITHER.size -= 4; // eat food
		}
		else
		{
			WHITHER.size += 2; // shrink
		}
		PS.border( x, y, WHITHER.size );

		if( ( x == WHITHER.gx ) && ( y == WHITHER.gy ) )
		{
			WHITHER.agp = 0;
			PS.borderAlpha( WHITHER.gx, WHITHER.gy, 255);
			WHITHER.nextLevel();
		}
		else if ( ( x == WHITHER.afx ) && ( y == WHITHER.afy ) )
		{
			WHITHER.afx = -1;
			WHITHER.afy = -1;
			WHITHER.afp = 0;
			PS.color( x, y, PS.COLOR_BLACK );
			PS.alpha( x, y, 255 );
		}
		else if ( WHITHER.size > 20 )
		{
			PS.color( PS.ALL, PS.ALL, PS.COLOR_BLACK );
			PS.border( PS.ALL, PS.ALL, 0 );
			PS.alpha( PS.ALL, PS.ALL, 255 );
			WHITHER.play = false;
			timer = PS.timerStart( 60, function ()
			{
				PS.timerStop( timer );
				if ( WHITHER.level > 1 )
				{
					WHITHER.level -= 1;
				}
				WHITHER.nextLevel();
				WHITHER.play = true;
			} );
		}
		else
		{
			if ( WHITHER.awx >= 0 )
			{
				alpha = PS.alpha( WHITHER.awx, WHITHER.awy ) - WHITHER.awp;
				if ( alpha < 0 )
				{
					alpha = 0;
				}
				PS.alpha( WHITHER.awx, WHITHER.awy, alpha );
				if( alpha === 0 )
				{
					PS.color( WHITHER.awx, WHITHER.awy, PS.COLOR_GRAY );
					PS.alpha( WHITHER.awx, WHITHER.awy, 255 );
					WHITHER.awx = -1;
					WHITHER.awy = -1;
					WHITHER.awp = 0;
				}
			}
			if ( WHITHER.afx >= 0 )
			{
				alpha = PS.alpha( WHITHER.afx, WHITHER.afy ) - WHITHER.afp;
				if ( alpha < 0 )
				{
					alpha = 0;
				}
				PS.alpha( WHITHER.afx, WHITHER.afy, alpha );
				if( alpha === 0 )
				{
					PS.color( WHITHER.afx, WHITHER.afy, PS.COLOR_GRAY );
					PS.alpha( WHITHER.afx, WHITHER.afy, 255 );
					WHITHER.afx = -1;
					WHITHER.afy = -1;
					WHITHER.afp = 0;
				}
			}
			if ( WHITHER.agp > 0 )
			{
				alpha = PS.borderAlpha( WHITHER.gx, WHITHER.gy ) - WHITHER.agp;
				if ( alpha < 0 )
				{
					alpha = 0;
				}
				PS.borderAlpha( WHITHER.gx, WHITHER.gy, alpha );
				if( alpha === 0 )
				{
					PS.borderColor( WHITHER.gx, WHITHER.gy, PS.COLOR_GRAY );
					PS.borderAlpha( WHITHER.gx, WHITHER.gy, 255 );
					WHITHER.gx = -1;
					WHITHER.gy = -1;
					WHITHER.agp = 0;
				}
			}
		}
	}
};

PS.init = function( system, options )
{
	"use strict";

	PS.gridSize( WHITHER.WIDTH, WHITHER.HEIGHT );
	PS.statusText( "" );
	PS.statusColor( PS.COLOR_WHITE );
	PS.gridColor( PS.COLOR_GRAY );
	//PS.fade( PS.ALL, PS.ALL, 60 );
	PS.audioLoad("whither");
	WHITHER.nextLevel();
};

PS.keyDown = function( key, shift, ctrl, options )
{
	"use strict";

	var x, y, dest;

	if ( !WHITHER.play )
	{
		return;
	}

	x = WHITHER.x;
	y = WHITHER.y;
	switch ( key )
	{
		case PS.KEY_ARROW_UP:
		case 87:
		case 119:
		{
			if ( y > 0 )
			{
				dest = PS.color( x, y - 1 );
				if ( ( dest === PS.COLOR_GRAY ) || ( dest === PS.COLOR_BLACK ) )
				{
					WHITHER.update( x, y - 1, dest );
				}
			}
			break;
		}
		case PS.KEY_ARROW_DOWN:
		case 83:
		case 115:
		{
			if ( y < WHITHER.YMAX )
			{
				dest = PS.color( x, y + 1 );
				if ( ( dest === PS.COLOR_GRAY ) || ( dest === PS.COLOR_BLACK ) )
				{
					WHITHER.update( x, y + 1, dest );
				}
			}
			break;
		}
		case PS.KEY_ARROW_LEFT:
		case 65:
		case 97:
		{
			if ( x > 0 )
			{
				dest = PS.color( x - 1, y );
				if ( ( dest === PS.COLOR_GRAY ) || ( dest === PS.COLOR_BLACK ) )
				{
					WHITHER.update( x - 1, y, dest );
				}
			}
			break;
		}
		case PS.KEY_ARROW_RIGHT:
		case 68:
		case 100:
		{
			if ( x < WHITHER.XMAX )
			{
				dest = PS.color( x + 1, y );
				if ( ( dest === PS.COLOR_GRAY ) || ( dest === PS.COLOR_BLACK ) )
				{
					WHITHER.update( x + 1, y, dest );
				}
			}
			break;
		}
		default:
		{
			break;
		}
	}
};

PS.keyUp = function(key,shift,ctrl,options)
{
	"use strict";
};

PS.input = function(sensors,options)
{
	"use strict";
};

PS.touch = function(x,y,data,options)
{
	"use strict";
};

PS.release = function(x,y,data,options)
{
	"use strict";
};

PS.enter = function(x,y,data,options)
{
	"use strict";
};

PS.exit = function(x,y,data,options)
{
	"use strict";
};

PS.exitGrid = function(options)
{
	"use strict";
};
